/*******************    ARQUIVO  INIT.C   *********************/
# define NOMAIN

# include <stdio.h>
# include <malloc.h>
# include <stdlib.h>
# include <time.h>

# include "include.h"
# include "struct.h"
# include "global.h"

EVENT *init_event();
float gera_tempo();

init_dados(nome_arq)
char 	*nome_arq;
  {
  int 	i,j,k;
  int 	num;
  char 	tipo,vc[11];
  FILE 	*fp;
  char 	str[TAM_MAX_LINHA+1],st[40],str_lec[40],c;
  int 	no_linha=0;
  int 	v[11];
  float vf[11];

  /* inicilizacao das estruturas de dados */

  n_fila=n_fonte=n_serv=n_fregues=n_max_fregues=0;
  t_simul=t_mostra_resul=t_fregues=0.;


  if((fp=fopen(nome_arq,"rt")) == NULL)
    {
    printf("O arquivo %s nao encontra-se.\n",nome_arq);
    exit(1);
    }
  while(1)
  {
  if(fgets(str,TAM_MAX_LINHA,fp) == NULL) break;
  no_linha++;
  switch(str[0])
  	{
  	case 'E' : /* Fonte */
  		   n_fonte++;
  		   if(sscanf(str,"%c %d %s %f %f",&c,v,st,vf,vf+1) != 5)
  		   	err_file(no_linha,1);
  		   tab_fonte[n_fonte].tipo=v[0];
  		   tab_fonte[n_fonte].nome = (char  *)malloc(strlen(st)+1);
  		   sprintf(tab_fonte[n_fonte].nome,st);
  		   switch(v[0]) {
  		   		case 1 : tab_fonte[n_fonte].t_proc_medio=vf[0];
  		   		         break;
  		   		case 2 : tab_fonte[n_fonte].t_proc_inf=vf[0];
  		   		         tab_fonte[n_fonte].t_proc_sup=vf[1];
  		   		         break;
  		   		default: err_file(no_linha,1);
  		   		}

  		   tipo='E';num=n_fonte;
  		   break;

  	case 'F' : /* Fila */
  		   n_fila++;
  		   if(sscanf(str,"%c %s",&c,st) != 2)
  		   	err_file(no_linha,1);
  		   tab_file[n_fila].nome = (char  *)malloc(strlen(st)+1);
  		   sprintf(tab_file[n_fila].nome,st);
  		   tipo='F';num=n_fila;
  		   break;

  	case 'S' : /* Servidor */
  		   n_serv++;
  		   if(sscanf(str,"%c %d %s %f %f",&c,v,st,vf,vf+1) != 5)
  		   	err_file(no_linha,1);
  		   tab_serv[n_serv].tipo=v[0];
  		   tab_serv[n_serv].nome = (char  *)malloc(strlen(st)+1);
  		   sprintf(tab_serv[n_serv].nome,st);
  		   switch(v[0]) {
  		   		case 1 : tab_serv[n_serv].t_proc_medio=vf[0];
  		   		         break;
  		   		case 2 : tab_serv[n_serv].t_proc_inf=vf[0];
  		   		         tab_serv[n_serv].t_proc_sup=vf[1];
  		   		         break;
  		   		default: err_file(no_linha,1);
  		   		}
  		   tipo='S';num=n_serv;
  		   break;

	case 'e' : /* Entradas */
	 	   if((tipo == 0) || (num == 0))
	 	   	err_file(no_linha,0);
		   if(sscanf(str,"%c %d ",&c,v) < 2)
		   	err_file(no_linha,1);
		   switch (tipo )
		   	{
		   	case 'E' : err_file(no_linha,2);
		   		   break;
		   	case 'S' : tab_serv[num].entrada=&(tab_file[v[0]]);
		   		   break;
		        }
		     break;

	case 's' : /* Saidas */
	 	   if((tipo == 0) || (num == 0))
		 	err_file(no_linha,0);
		   if((i=sscanf(str,"%c %d %d %d %d %d",&c,v,v+1,v+2,v+3,v+4)) < 2)
			err_file(no_linha,1);
		   switch (tipo )
		   	{
		   	case 'E' : /*for(i=0;i<tab_fonte[num].nb_saida;i++)*/
		   	  	     if(v[0]==0)
		   		       tab_fonte[num].saida=NULL;
		   		     else
		   		       tab_fonte[num].saida=&(tab_file[v[0]]);

		   		   break;
		   	case 'F' : /*for(i=0;i<tab_file[num].nb_saida;i++)*/
		   		     if(v[0]==0)
		   		       tab_file[num].saida=NULL;
		   		     else
		   		     tab_file[num].saida=&(tab_serv[v[0]]);
		   		   break;
		   	case 'S' : /*for(i=0;i<tab_serv[num].nb_saida;i++)*/
		   		     if(v[0]==0)
		   		       tab_serv[num].saida=NULL;
		   		     else
		   		       tab_serv[num].saida=&(tab_file[v[0]]);
		   		   break;
		        }
		     break;

	case 'D' : /* Duracao da simulacao */
	           if((i=sscanf(str,"%c %f",&c,&t_max_simul)) != 2)
	           	err_file(no_linha,1);
	           break;

        case 'N' : /* Numero max de fregues a processar */
	           if((i=sscanf(str,"%c %d",&c,&n_max_fregues)) != 2)
	           	err_file(no_linha,1);
	            break;
	case 'V' : /* Visualizacao durante a simulacao */
	           if((i=sscanf(str,"%c %d",&c,&flag_trace)) != 2)
	           	err_file(no_linha,1);

	default	 :  break;
	}
  } /* fim while(1) */
}

init()
{
int 	i,j,k;

for(i=1;i<n_fonte+1;i++)
  {
  tab_fonte[i].n_tot=0;
  }
for(i=1;i<n_serv+1;i++)
  {
  tab_serv[i].n_tot=0;
  tab_serv[i].fregues=FALSE;
  tab_serv[i].t_ocupado=0.;
  tab_serv[i].t_tot_ocupado=0.;
  }
for(i=1;i<n_fila+1;i++)
  {
  tab_file[i].n_tot = 0;
  tab_file[i].n_cour = 0;
  tab_file[i].n_max = 0;
  tab_file[i].t_sim_ant = 0.;
  tab_file[i].n_tam_ant = 0;
  tab_file[i].tot_tam_acum = 0.;
  }
}

err_file(no_linha,tipo)
int 	no_linha,tipo;
{
printf("Arquivo de dados : erro linha  - %d - \n",no_linha);
switch (tipo)
	{
	case 0 : printf(" 	Este parametro nao se usa com este objeto\n");
		 break;
	case 1 : printf(" 	Numero de parametros invalido\n");
		 break;
	case 2 : printf(" 	Ligacao entre objetos incompativeis\n");
		 break;
	case 3 : printf(" 	Numero de parametros invalido\n");
		 break;
	case 4 : printf(" 	O tempo de simulacao nao encontra-se\n");
		 break;
	case 5 : printf(" 	O tempo de amostragem nao encontra-se\n");
		 break;
	case 6 : printf(" 	O tempo de chegada dos fregues nao encontra-se\n");
		 break;
	default: break;
	}

exit(1);
}

init_rand()
{
int 	stime;
long 	ltime;

ltime=time(NULL);
stime = (unsigned) ltime/2;
srand(stime);
}

init_lista_event()
{
int i;
EVENT *event;
float t_event;

for(i=1;i<=n_fonte;i++)
  {
  t_event=gera_tempo(tab_fonte[i].tipo,tab_fonte[i].t_proc_medio,tab_fonte[i].t_proc_inf,tab_fonte[i].t_proc_sup);
  event=init_event(COD_FONTE,&(tab_fonte[i]),t_event);
  insere_event(event);
  }
}












